<script setup lang="ts">
import { ref } from 'vue'
import { useRouter } from 'vue-router'
import { useVuelidate } from '@vuelidate/core'
import { required } from '@vuelidate/validators'
import MsnApi from '@/api/msnApi'

// ONLY FOR TESTING TODO DELETE
const firstName = ref('')
const email = ref('')
const mobile = ref<number>()
const password = ref<string>()
const checkbox = ref(false)

const eventData = ref({ name: '' })
const saving = ref(false)
const isRequest = ref(false)
const requestMessage = ref('')
const isError = ref(false)
const router = useRouter()

const rules = {
  eventData: {
    name: { required },
  },
}

const v$ = useVuelidate(rules, { eventData })

const resetForm = () => {
  eventData.value.name = ''
  v$.value.$reset()
}

const validateAndSubmit = async () => {
  console.log('Submit triggered')
  v$.value.$touch()
  if (!v$.value.$invalid) {
    console.log('Submit triggered! Entering SaveFunction')
    await saveEvent()
  }
  else {
    console.log('Form is invalid, current errors:', v$.value.$errors)
    console.log('Form eventData.value', eventData.value)
    console.log('Form eventData.value.name', eventData.value.name)
  }
}

const saveEvent = async () => {
  saving.value = true
  console.debug('this.eventData: ', eventData.value)

  const api = new MsnApi()
  try {
    const response = await api.createEvent(eventData.value)

    console.debug('responseEventData: ', JSON.parse(JSON.stringify(response.data)))
    requestMessage.value = response.data.message
    isError.value = false
    await router.push({ name: 'settings-events-list' })
  }
  catch (error) {
    console.error('Error saving event', error)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')
</script>

<template>
  <VForm
    ref="newEventForm"
    class="mt-2"
    @submit.prevent="validateAndSubmit"
  >
    <VRow>
      <VCol cols="12">
        <VRow no-gutters>
          <!-- 👉 First Name -->
          <VCol
            cols="12"
            md="3"
            class="d-flex align-items-center"
          >
            <label
              class="v-label text-body-2 text-high-emphasis"
              for="firstName"
            >Event Name</label>
          </VCol>

          <VCol
            cols="12"
            md="9"
          >
            <VTextField
              id="eventName"
              v-model="eventData.name"
              persistent-placeholder
              placeholder="Event Name"
              autocomplete="off"
            />
          </VCol>
        </VRow>
      </VCol>

      <VCol md="12">
        <VAlert
          v-if="isRequest"
          :type="alertToggleVariant"
          dense
        >
          <VIcon left>
            mdi-information
          </VIcon>
          <strong>{{ alertToggleText }}</strong> {{ requestMessage }}.
        </VAlert>
      </VCol>

      <!-- 👉 submit and reset button -->
      <VCol
        offset-md="3"
        cols="12"
        md="9"
        class="d-flex gap-4"
      >
        <VBtn
          color="primary"
          class="mt-2 mr-1"
          :loading="saving"
          :disabled="saving"
          type="submit"
        >
          Submit
        </VBtn>
        <VBtn
          color="secondary"
          variant="tonal"
          type="reset"
          class="mt-2"
          @click="resetForm"
        >
          Reset
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped>

</style>
